# The Book of dwarf

[Introduction](./introduction.md)
[Language Walkthrough](./overview.md)
# Examples

- [Mandelbrot Set](./tutorials/mandelbrot.md)
    - [Coding a Complex Type](./tutorials/mandelbrot/complex.md)
    - [Mapping Points to Pixels]()
    - [Rendering the Set](./tutorials/mandelbrot/render_0.md)
    - [Speeding it up]()

- [Python Bindings]()

# Reference

- [Dwarf Language Reference]()
    - [Items]()
        - [Enumerations](./reference/enums.md)
        - [Functions](./reference/functions.md)
        - [Imports](./reference/imports.md)
        - [Patterns](./reference/patterns.md)
        - [Structs](./reference/structs.md)
    - [Statements](./reference/statements.md)
    - [Expressions]()
        - [Literal Expressions](./reference/expressions/literal.md)
        - [Unary Expressions](./reference/expressions/unary.md)
        - [Binary Expressions](./reference/expressions/binary.md)
    - [Types]()
        - [Built-in Types](./reference/built-in-types.md)
        - [User-defined Types](./reference/udts.md)
    - [Inline Assembly]()
    - [Object Oriented Features]()

- [ChaCha Runtime Reference](./chacha.md)

- [The Future]()

- [For Hackers](./hacker.md)
    - [Building]()
        - [Tools]()
        - [Benchmarks]()
    - [Architecture]()
        - [Parser](./hacker/arch/parser.md)
        - [Compiler]()
        - [Chacha]()
            - [Async Implementation](./hacker/arch/chacha/async.md)
            - [Interpreter]()
            - [VM]()
        - [The ObjectStore]()
    - [Code Generation]()
    - [Dwarf Language]()
        - [Generic Types](./hacker/dwarf/generics.md)

[Index](./directory.md)

---

[Postface](./preface.md)
